/* 
 * Header File della classe CampioneSingolo
 */

#ifndef SAMPLE_H
#define SAMPLE_H

#include "Immagine.h"
#include "RettBoundingBox.h"

#include <vector>

class CampioneSingolo
{
public:
	CampioneSingolo(const Immagine &immagine, const FloatRect& roi) :
		Mia_Immagine(immagine),
		Mia_Roi(roi)
	{
	}
	
	inline const Immagine & GetImage() const { return Mia_Immagine; }
	inline const FloatRect& GetROI() const { return Mia_Roi; }

private:
	const Immagine &Mia_Immagine;
	FloatRect Mia_Roi;
};

class MultiCampione
{
public:
	MultiCampione(const Immagine &immagine, const std::vector<FloatRect>& rects) :
		Mia_Immagine(immagine),
		Miei_Rett(rects)
	{
	}
	
	inline const Immagine & GetImage() const { return Mia_Immagine; }
	inline const std::vector<FloatRect>& GetRects() const { return Miei_Rett; }
	inline CampioneSingolo GetSample(int i) const { return CampioneSingolo(Mia_Immagine, Miei_Rett[i]); }

private:
	const Immagine &Mia_Immagine;
	std::vector<FloatRect> Miei_Rett;
};

#endif
