/* 
 * File cpp della classe FeatureHaarSingola
 */

#include "FeatureHaarSingola.h"
#include "CampioneSingolo.h"

using namespace std;

HaarFeature::HaarFeature(const FloatRect& bb, int type) :
	Mio_BB(bb)
{
	assert(type < 6);
	
	switch (type)
	{
	case 0:
		{
			Miei_Rects.push_back(FloatRect(bb.XMin(), bb.YMin(), bb.Width(), bb.Height()/2));
			Miei_Rects.push_back(FloatRect(bb.XMin(), bb.YMin()+bb.Height()/2, bb.Width(), bb.Height()/2));
			Pesi.push_back(1.f);
			Pesi.push_back(-1.f);
			Factor = 255*1.f/2;
			break;
		}
	case 1:
		{
			Miei_Rects.push_back(FloatRect(bb.XMin(), bb.YMin(), bb.Width()/2, bb.Height()));
			Miei_Rects.push_back(FloatRect(bb.XMin()+bb.Width()/2, bb.YMin(), bb.Width()/2, bb.Height()));
			Pesi.push_back(1.f);
			Pesi.push_back(-1.f);
			Factor = 255*1.f/2;
			break;
		}
	case 2:
		{
			Miei_Rects.push_back(FloatRect(bb.XMin(), bb.YMin(), bb.Width()/3, bb.Height()));
			Miei_Rects.push_back(FloatRect(bb.XMin()+bb.Width()/3, bb.YMin(), bb.Width()/3, bb.Height()));
			Miei_Rects.push_back(FloatRect(bb.XMin()+2*bb.Width()/3, bb.YMin(), bb.Width()/3, bb.Height()));
			Pesi.push_back(1.f);
			Pesi.push_back(-2.f);
			Pesi.push_back(1.f);
			Factor = 255*2.f/3;
			break;
		}
	case 3:
		{
			Miei_Rects.push_back(FloatRect(bb.XMin(), bb.YMin(), bb.Width(), bb.Height()/3));
			Miei_Rects.push_back(FloatRect(bb.XMin(), bb.YMin()+bb.Height()/3, bb.Width(), bb.Height()/3));
			Miei_Rects.push_back(FloatRect(bb.XMin(), bb.YMin()+2*bb.Height()/3, bb.Width(), bb.Height()/3));
			Pesi.push_back(1.f);
			Pesi.push_back(-2.f);
			Pesi.push_back(1.f);
			Factor = 255*2.f/3;
			break;
		}
	case 4:
		{
			Miei_Rects.push_back(FloatRect(bb.XMin(), bb.YMin(), bb.Width()/2, bb.Height()/2));
			Miei_Rects.push_back(FloatRect(bb.XMin()+bb.Width()/2, bb.YMin()+bb.Height()/2, bb.Width()/2, bb.Height()/2));
			Miei_Rects.push_back(FloatRect(bb.XMin(), bb.YMin()+bb.Height()/2, bb.Width()/2, bb.Height()/2));
			Miei_Rects.push_back(FloatRect(bb.XMin()+bb.Width()/2, bb.YMin(), bb.Width()/2, bb.Height()/2));
			Pesi.push_back(1.f);
			Pesi.push_back(1.f);
			Pesi.push_back(-1.f);
			Pesi.push_back(-1.f);
			Factor = 255*1.f/2;
			break;
		}
	case 5:
		{
			Miei_Rects.push_back(FloatRect(bb.XMin(), bb.YMin(), bb.Width(), bb.Height()));
			Miei_Rects.push_back(FloatRect(bb.XMin()+bb.Width()/4, bb.YMin()+bb.Height()/4, bb.Width()/2, bb.Height()/2));
			Pesi.push_back(1.f);
			Pesi.push_back(-4.f);
			Factor = 255*3.f/4;
			break;
		}				
	}
}

HaarFeature::~HaarFeature()
{
}

float HaarFeature::Eval(const CampioneSingolo & s) const
{
	const Immagine & image = s.GetImage();
	const FloatRect& roi = s.GetROI();
	float value = 0.f;
	for (int i = 0; i < (int) Miei_Rects.size(); ++i)
	{
		const FloatRect& r = Miei_Rects[i];
		IntRect sampleRect((int)(roi.XMin()+r.XMin()*roi.Width()+0.5f), (int)(roi.YMin()+r.YMin()*roi.Height()+0.5f),
			(int)(r.Width()*roi.Width()), (int)(r.Height()*roi.Height()));
		value += Pesi[i]* image.Somma(sampleRect);
	}
	return value / (Factor *roi.Area()* Mio_BB.Area());
}