/* 
 * Header File della classe FileConfigurazione
 */

#ifndef CONFIG_H
#define CONFIG_H

#include <vector>
#include <string>
#include <ostream>

#define VERBOSE (0)

class FileConfigurazione
{
public:
	FileConfigurazione() { SettaValoriDefault(); }
	FileConfigurazione(const std::string& path);
	
	enum TipoFeature
	{
		kFeatureTipoHaar,
		kFeatureTipoRaw,
		kFeatureTipoIstogramma
	};

	enum TipoKernel
	{
		kKernelTipoLineare,
		kKernelTipoGaussiano,
		kKernelTipoIntersection,
		kKernelTipoChi2
	};

	struct CoppiaFeatureKernel
	{
		TipoFeature feature;
		TipoKernel kernel;
		std::vector<double> params;//Parametri
	};

	bool							quietMode;
	bool							debugMode;
	
	std::string						sequenceBasePath;
	std::string						sequenceName;
	std::string						resultsPath;
	
	int								frameWidth;
	int								frameHeight;
	
	int								seed;
	int								searchRadius;
	double							svmC;
	int								svmBudgetSize;
	std::vector<CoppiaFeatureKernel> TipologiaFeatures;
	
	friend std::ostream& operator<< (std::ostream& out, const FileConfigurazione & conf);
	
private:
	void SettaValoriDefault();
	static std::string NomeFeature(TipoFeature f);
	static std::string NomeKernel(TipoKernel k);
};

#endif