/* 
 * HeaderFile della classe Immagine
 */

#ifndef IMAGE_REP_H
#define IMAGE_REP_H

#include "RettBoundingBox.h"

#include <opencv/cv.h>
#include <vector>

#include <../Eigen/Eigen/Core>

class Immagine
{
public:
	Immagine(const cv::Mat& rImage, bool computeIntegral, bool computeIntegralHists, bool colour = false);
	
	int Somma(const IntRect &rRect, int channel = 0) const;
	void Istogramma(const IntRect &rRect, Eigen::VectorXd &h) const;
	
	inline const cv::Mat&GetImmagine(int channel = 0) const { return Immagini[channel]; }
	inline const IntRect& GetRect() const { return Mio_Rect; }

private:
	std::vector<cv::Mat> Immagini;
	std::vector<cv::Mat> ImmaginiIntegrali;
	std::vector<cv::Mat> IstrogrammiImmaginiIntegrali;
	int Canali;
	IntRect Mio_Rect;
};

#endif
